// CheckMemorryCmd.h: the interface of the CCheckMemorryCmd class
//
// This software can be offered for free and used as necessary to aid 
// in your program developments.
//
// RENESAS TECHNOLOGY CORPORATION, RENESAS SOLUTIONS CORPORATION,
// and related original software developers assume no responsibility 
// for any damage or infringement of any third-party's rights, originating 
// in the use of the following software.
// Please use this software under the agreement and acceptance of these conditions. 
//
// Copyright(C)1998(2003) RENESAS TECHNOLOGY CORPORATION AND RENESAS SOLUTIONS CORPORATION
// ALL RIGHTS RESERVED
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CHECKMEMORRYCMD_H__C8D448A5_1AF9_11D2_AEFD_00C04FD601E8__INCLUDED_)
#define AFX_CHECKMEMORRYCMD_H__C8D448A5_1AF9_11D2_AEFD_00C04FD601E8__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "Command.h"

class CCheckMemorryCmd : public CCommand  
{
public:
	CCheckMemorryCmd();
	virtual ~CCheckMemorryCmd();
    
/////////////////////////////////////////////////////////////////////

	// The cipher of a hexadecimal number is combined to nDigit.
protected: void ResetDigit(CString* strHex, int nDigit);

	// The letter line that shows the hexadecimal number is transformed into the int style.
protected: unsigned int StrToHex(CString strHex);

	// The int style is transformed into the letter line that shows the hexadecimal number.
protected: CString HexToStr(unsigned int nXdigit);

	// I acquire the address from the dialog.
public: BOOL GetAddressFromDialog(unsigned int* nStartAddress, unsigned int* nEndAddress, int nDigit);

	// I acquire the address of the range of the file where at present I am reading.
public: BOOL GetFileAddress(unsigned int* nStartAddress, unsigned int* nEndAddress, int ndigit);

	// add EPRCommand function
public: void GetFileAddressOnly(unsigned int* nStartAddress, unsigned int* nEndAddress);
	// add end EPRCommand function

	// An address is transformed into the data of the transmission form.
public: void ToSendStyle(int nAddress, BYTE* byteHi, BYTE* byteMid);
	BOOL GetDownloadAddress(unsigned int * nStartAddress, unsigned int * nEndAddress, int nDigit);
	void BlankPage(BYTE bytePage[PAGE_SIZE]);

	// I implement the lead command.
protected: BOOL DoRead(CSerialComm* pComObj, BYTE* receive, unsigned int nAddress);

	// I check the size of the start address and end address.
protected: BOOL ChkStartToEnd(unsigned int nStart, unsigned int nEnd);

	// /I arrange an address.
protected: unsigned int AddressToPage(unsigned int nAddress) { return nAddress - nAddress % 0x0100; }

	// It does a page the clear.
protected: void ClearPage(BYTE bytePage[PAGE_SIZE]);

};

#endif // !defined(AFX_CHECKMEMORRYCMD_H__C8D448A5_1AF9_11D2_AEFD_00C04FD601E8__INCLUDED_)
