// MotFile.h: CMotFile Interface of the CMotFile class   
//
// This software can be offered for free and used as necessary to aid 
// in your program developments.
//
// RENESAS TECHNOLOGY CORPORATION, RENESAS SOLUTIONS CORPORATION,
// and related original software developers assume no responsibility 
// for any damage or infringement of any third-party's rights, originating 
// in the use of the following software.
// Please use this software under the agreement and acceptance of these conditions. 
//
// Copyright(C)1998(2003) RENESAS TECHNOLOGY CORPORATION AND RENESAS SOLUTIONS CORPORATION
// ALL RIGHTS RESERVED
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MOTFILE_H__2C283F49_1C8C_11D2_AEFD_00C04FD601E8__INCLUDED_)
#define AFX_MOTFILE_H__2C283F49_1C8C_11D2_AEFD_00C04FD601E8__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "LineImage.h"

class CMotFile  
{
public:
	CMotFile();
	virtual ~CMotFile();

//////// Minute when I added later ///////////////////////////////////////
//////// Member variable //////////////////////////////////////////////////

private: CPtrArray m_pArrayPage;

//////// function ////////////////////////////////////////////////////////	

	// Transform the data of 1 column.  
private: BYTE charToByte(TCHAR chHex);

	// Transform the data of 1 byte.  
private: BOOL strToByte(BYTE* byteHex, CString strHex);

	// Check the record type.  
private: int getRecType(CString strLine);

	// Check the length of data.  
private: int getDataLength(CString strLine);

	//  Transform a line of a Mot file.  
private: BOOL lineToBytes(BYTE* byteLine, CString strLine);

    // Acquire the address from a line of a Mot file.  
private: int getAddress(CString strLine);

	// Check whether the line is not sitting astride in a page.   
private: BOOL isOverPage(CString strLine);

	// Make transmission data from a Mot file.   
public: BOOL MakeImage(CString strFinePath);

	// Take out the data of the page that was designated.  
public: CLineImage* GetPage(BYTE* byteData, int nPage);

};

#endif // !defined(AFX_MOTFILE_H__2C283F49_1C8C_11D2_AEFD_00C04FD601E8__INCLUDED_)
