// SaveIni.h: CSaveIni Class interface
//
// This software can be offered for free and used as necessary to aid 
// in your program developments.
//
// RENESAS TECHNOLOGY CORPORATION, RENESAS SOLUTIONS CORPORATION,
// and related original software developers assume no responsibility 
// for any damage or infringement of any third-party's rights, originating 
// in the use of the following software.
// Please use this software under the agreement and acceptance of these conditions. 
//
// Copyright(C)1998(2003) RENESAS TECHNOLOGY CORPORATION AND RENESAS SOLUTIONS CORPORATION
// ALL RIGHTS RESERVED
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SAVEINI_H__2A798D43_2531_11D2_AEFD_00C04FD601E8__INCLUDED_)
#define AFX_SAVEINI_H__2A798D43_2531_11D2_AEFD_00C04FD601E8__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000


typedef struct comm_tag {
			DWORD dwBaudRate;
			BYTE btByteSize;
			BYTE btStopBits;
			BYTE btParity;
		} COMM;

class CSaveIni  
{
public:
	CSaveIni();
	virtual ~CSaveIni();

////////////////////////////////////////////////////////////////

	// Communication set / access
private: COMM m_structComm;
public: void SetComm(DWORD dwBaudRate, BYTE btByteSize, BYTE btStopBits, BYTE btParity);
public: void GetComm(DWORD* dwBaudRate, BYTE* btByteSize, BYTE* btStopBits, BYTE* btParity);
public: void SaveComm(void);
public: const struct comm_tag* LoadComm(void);
	
	// Start condition set / access
private: CString m_str_D_Type;
public: void SetDType(CString D_Type);
public: void GetDType(CString *D_Type);
public: void SaveDType(void);
public: const CString* LoadDType(void);
private: CString m_str_Z_Type;
public: void SetZType(CString Z_Type);
public: void GetZType(CString *Z_Type);
public: void SaveZType(void);
public: const CString* LoadZType(void);
	//
public: DWORD GetReadTimeout(DWORD defTimeout);

};

#endif // !defined(AFX_SAVEINI_H__2A798D43_2531_11D2_AEFD_00C04FD601E8__INCLUDED_)
